// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float4x4 wvp                : WorldViewProjection;
texture tex0                : Texture;
float4 object_color         : ObjectColor;
float4 material_diffuse     : Diffuse;
float u_offset = 0.0;
float v_offset = 0.0;
float alpha = 1.0;

sampler samp = sampler_state
{
    Texture = (tex0);
};

// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VSOutput
{
    float4 pos  : POSITION;
    float4 col  : COLOR0;
    float2 tex  : TEXCOORD0;
};
VSOutput VS(
    float4 pos			    : POSITION,		// f̒_
    float2 tex			    : TEXCOORD0    // eNX`W
){
    VSOutput output = (VSOutput)0;
	
	output.pos = mul(pos,wvp);
    output.col = material_diffuse;
    output.tex = tex;

    return output;
}

VSOutput VSuvanim(
    float4 pos			    : POSITION,		// f̒_
    float2 tex			    : TEXCOORD0    // eNX`W
){
    VSOutput output = (VSOutput)0;
	
	output.pos = mul(pos,wvp);
    //output.col = material_diffuse;
    output.col = float4(alpha,alpha,alpha,0.0);
    //tex.u += u_offset;
    //tex.v += v_offset;
    tex = tex + float2(u_offset, v_offset);
    output.tex = tex;

    return output;
}

float4 PS(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
//    return tex2D( samp, tex );
    return tex2D( samp, tex ) * col;
}

float4 PS3(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
//    return tex2D( samp, tex );
    return tex2D( samp, tex ) + col;
}
float4 PS2(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
    return tex2D( samp, tex );
}



technique TechAdd
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = false;
        AlphaBlendEnable = TRUE;
        DestBlend        = One;  
        
        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS();
    }
}


technique TechNormal
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = true;
        
        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS();
    }
}

technique TechAlpha
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = false;
        AlphaBlendEnable = TRUE;
        //DestBlend        = One;  
        SrcBlend         = SRCALPHA;
        DestBlend        = InvSrcAlpha;  
        
        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS();
    }
}

technique TechAlpha2
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = false;
        AlphaBlendEnable = TRUE;
        //DestBlend        = One;  
        SrcBlend         = SRCALPHA;
        DestBlend        = InvSrcAlpha;  
        
        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS2();
    }
}

technique TechMulti
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = False;
        AlphaBlendEnable = TRUE;
        SrcBlend         = DESTCOLOR;
        DestBlend        = ZERO; 
    	CullMode = None;
        VertexShader = compile vs_2_0 VSuvanim();
        PixelShader = compile ps_2_0 PS3();
    }
}

