// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 world_view         : WorldView;
float4x4 projection         : Projection;
float4 object_color         : ObjectColor;

// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VSOutput
{
    float4 pos  : POSITION;
    float4 col  : COLOR0;
    float2 tex  : TEXCOORD0;
};

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VSOutput VS_Particle(
    float4 pos  : POSITION,		// p[eBNP̒S
    float4 col  : COLOR,		// p[eBNP̐F
    float2 tex  : TEXCOORD0,	// eNX`W
    float2 vpos : TEXCOORD1,	// _̃p[eBNS̃ItZbg(ViewWn)
    float  rot  : TEXCOORD2		// p[eBNP̉](ViewWn)
){
    VSOutput output;
	
	float4 offset = float4( cos(rot) * vpos.x - sin(rot) * vpos.y,
					 		sin(rot) * vpos.x + cos(rot) * vpos.y,
						    0.0,
						    0.0 );
	
    output.pos = mul( mul( pos, world_view) + offset, projection );

    output.col = col * object_color;
    output.tex = tex;

    return output;
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique Tech_Alpha
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS_Particle();
        AlphaBlendEnable = TRUE;
        DestBlend        = One;
    	CullMode = None;
        ZwriteEnable     = FALSE;
    }
}
technique Tech_Add
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS_Particle();
        ZEnable = true;
        ZWriteEnable = false;
        AlphaBlendEnable = TRUE;
        DestBlend        = One;  
    	CullMode = None;
    }
}

